package nedelja3;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;


public class Memorija {
    public List <Student>bazaPodataka;
    public String nazivBazePodataka;

    public Memorija(String nazivBazePodataka) {
        this.bazaPodataka = new ArrayList<>();
        this.nazivBazePodataka = nazivBazePodataka;
    }
    
    public void unesiStudenta(Student s){
        this.bazaPodataka.add(s);
        System.out.println("Student "+s.getImePrezime()+" dodat u bazu podataka!");
    }
    public void prikaziStudente(){
        Iterator <Student> it = this.bazaPodataka.iterator();
        System.out.println("Lista studenata u bazi podataka...........");
        while(it.hasNext()){
            Student temp = it.next();
            System.out.println("Student: "+temp.getImePrezime()+" Indeks: "+temp.getBrojIndeksa());
        }
        System.out.println("U bazi podataka postoji "+this.bazaPodataka.size()+" studenata.");
    }
    public void pronadjiStudenta(String imePrezime){
        Iterator <Student> it = this.bazaPodataka.iterator();
        System.out.println("Rezultati pretrage...........");
        while(it.hasNext()){
            Student temp = it.next();
            if(temp.getImePrezime().equalsIgnoreCase(imePrezime)){
                System.out.println("Student: "+temp.getImePrezime()+" Indeks: "+temp.getBrojIndeksa());
                break;
            }
        }
    }
    public void upisiFajl(String nazivFajla) throws IOException{//mojfajl.txt
        FileWriter fw = new FileWriter(nazivFajla);
        PrintWriter pw = new PrintWriter(fw);
        //nas kod
        Iterator<Student> it = this.bazaPodataka.iterator();
        while (it.hasNext()) {
            Student temp = it.next();
            pw.println(
                      temp.getImePrezime() + "#"
                    + temp.getJmbg() + "#"
                    + temp.getFakultet() + "#"
                    + temp.getBrojIndeksa() + "#"
                    + temp.getPolozeniIspiti());
        }


        pw.close();
        fw.close();
    }
    
    public void ucitajFajl(String nazivFajla) throws FileNotFoundException, IOException{
        
        FileInputStream fis = new FileInputStream(nazivFajla);
        BufferedInputStream bis = new BufferedInputStream(fis);
        DataInputStream dis = new DataInputStream(bis);
        //Sasa Adamovic#1234567896321#Informatika#2015/104004#5
        //Student(String imePrezime, String jmbg, int polozeniispiti, String fakultet, String indeks  )
        String temp[] = null;
        Student t = null;
        while(dis.available()!=0){
            temp = dis.readLine().split("#");
            t = new Student(temp[0], temp[1], Integer.parseInt(temp[4]), temp[2], temp[3]);
            this.unesiStudenta(t);
        }
    }
    
    public void ucitajTabelu(JTable jt){
        String nazivKolona[] ={
            "Ime i prezime",
            "JMBG",
            "Indeks",
            "Fakultet",
            "Polozeni ispiti"};
        Object podaci[][] = new Object[this.bazaPodataka.size()][5];
        
        //ucitavanje podataka
        Iterator <Student> it = this.bazaPodataka.iterator();
        
        Object tempPodaci[] = null;
        int brojac = 0;
        while(it.hasNext()){
            Student temp = it.next();  
            tempPodaci = new Object[5];
            tempPodaci[0] = temp.getImePrezime();
            tempPodaci[1] = temp.getJmbg();
            tempPodaci[2] = temp.getBrojIndeksa();
            tempPodaci[3] = temp.getFakultet();
            tempPodaci[4] = temp.getPolozeniIspiti();
            podaci[brojac] = tempPodaci;
            brojac++;
        }
        DefaultTableModel DTM = new DefaultTableModel(podaci, nazivKolona);
        jt.setModel(DTM);
    }
    
}
